// Generated by actions/crud/CrudAction.java.vsl in cartridge andromda-bpm4struts
// license-header java merge-point
package org.andromda.samples.crud.flower.crud;

import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.andromda.samples.crud.ManageableServiceLocator;
import org.apache.commons.lang.StringUtils;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.actions.DispatchAction;

public final class ManageFlower extends DispatchAction
{
    public ActionForward execute(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        request.getSession().setAttribute("manageableForm", actionForm);
        return super.execute(mapping, actionForm, request, response);
    }

    public ActionForward create(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final FlowerForm form = (FlowerForm)actionForm;

        ManageableServiceLocator.instance().getFlowerManageableService().create(
            (StringUtils.isBlank(request.getParameter("smellsBad"))) ? false : form.isSmellsBad()
            , (StringUtils.isBlank(request.getParameter("name"))) ? null : form.getName()
            , (StringUtils.isBlank(request.getParameter("description"))) ? null : form.getDescription()
            // we don't test using request.getParameter because for file uploads this will always return null
            , (form.getPicture() == null) ? null : form.getPicture().getFileData()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("garden"))) ? null : form.getGarden()
            , (StringUtils.isBlank(request.getParameter("colors"))) ? null : form.getColors()
        );

        return preload(mapping, actionForm, request, response);
    }

    public ActionForward read(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final FlowerForm form = (FlowerForm)actionForm;

        final List list = ManageableServiceLocator.instance().getFlowerManageableService().read(
            (StringUtils.isBlank(request.getParameter("smellsBad"))) ? false : form.isSmellsBad()
            , (StringUtils.isBlank(request.getParameter("name"))) ? null : form.getName()
            , (StringUtils.isBlank(request.getParameter("description"))) ? null : form.getDescription()
            ,  null
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("garden"))) ? null : form.getGarden()
            , (StringUtils.isBlank(request.getParameter("colors"))) ? null : form.getColors()
        );
        form.setManageableList(list);

        if (list.size() >= 250)
        {
            saveMaxResultsWarning(request);
        }

        final Map backingLists = ManageableServiceLocator.instance().getFlowerManageableService().readBackingLists();
        form.setGardenBackingList((List)backingLists.get("garden"));
        form.setColorsBackingList((List)backingLists.get("colors"));

        return mapping.getInputForward();
    }

    public ActionForward preload(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final FlowerForm form = (FlowerForm)actionForm;

        final List list = ManageableServiceLocator.instance().getFlowerManageableService().readAll();
        form.setManageableList(list);


        if (list.size() >= 250)
        {
            saveMaxResultsWarning(request);
        }

        final Map backingLists = ManageableServiceLocator.instance().getFlowerManageableService().readBackingLists();
        if (StringUtils.isNotBlank(request.getParameter("ref_Garden")))
        {
            form.setGarden(new Long(request.getParameter("ref_Garden")));
        }
        form.setGardenBackingList((List)backingLists.get("garden"));
        if (StringUtils.isNotBlank(request.getParameter("ref_Color")))
        {
            final Long[] array = new Long[1];
            array[0] = new Long(request.getParameter("ref_Color"));
            form.setColors(array);
        }
        form.setColorsBackingList((List)backingLists.get("colors"));

        return mapping.getInputForward();
    }

    protected ActionForward unspecified(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        return preload(mapping, actionForm, request, response);
    }

    public ActionForward update(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final FlowerForm form = (FlowerForm) actionForm;

        ManageableServiceLocator.instance().getFlowerManageableService().update(
            (StringUtils.isBlank(request.getParameter("smellsBad"))) ? false : form.isSmellsBad()
            , (StringUtils.isBlank(request.getParameter("name"))) ? null : form.getName()
            , (StringUtils.isBlank(request.getParameter("description"))) ? null : form.getDescription()
            // we don't test using request.getParameter because for file uploads this will always return null
            , (form.getPicture() == null) ? null : form.getPicture().getFileData()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("garden"))) ? null : form.getGarden()
            , (StringUtils.isBlank(request.getParameter("colors"))) ? null : form.getColors()
        );

        return preload(mapping, actionForm, request, response);
    }

    public ActionForward delete(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final FlowerForm form = (FlowerForm) actionForm;

        final Long[] selectedRows = form.getSelectedRows();
        if (selectedRows != null && selectedRows.length > 0)
        {
            ManageableServiceLocator.instance().getFlowerManageableService().delete(selectedRows);
        }

        return preload(mapping, actionForm, request, response);
    }

    public ActionForward getPicture(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final FlowerForm form = (FlowerForm) actionForm;
        final byte[] picture = ManageableServiceLocator.instance().getFlowerManageableService().getPicture(form.getId());

        if (picture != null)
        {
            response.setContentType("application/octet-stream");
            response.setContentLength(picture.length);
            response.setHeader("Content-disposition", "attachment; filename=flower-picture.bin");
            response.getOutputStream().write(picture);
        }

        // let the browser simply download the field, do not forward
        return null;
    }

    private void saveMaxResultsWarning(HttpServletRequest request)
    {
        final HttpSession session = request.getSession();

        ActionMessages messages = (ActionMessages)session.getAttribute(Globals.MESSAGE_KEY);
        if (messages == null)
        {
            messages = new ActionMessages();
            session.setAttribute(Globals.MESSAGE_KEY, messages);
        }
        messages.add("org.andromda.bpm4struts.warningmessages", new ActionMessage("maximum.results.fetched.warning", "250"));
    }

}