// Generated by actions/crud/CrudAction.java.vsl in cartridge andromda-bpm4struts
// license-header java merge-point
package org.andromda.samples.crud.garden.crud;

import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.andromda.samples.crud.ManageableServiceLocator;
import org.apache.commons.lang.StringUtils;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.actions.DispatchAction;

public final class ManageGarden extends DispatchAction
{
    public ActionForward execute(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        request.getSession().setAttribute("manageableForm", actionForm);
        return super.execute(mapping, actionForm, request, response);
    }

    public ActionForward create(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final GardenForm form = (GardenForm)actionForm;

        ManageableServiceLocator.instance().getGardenManageableService().create(
            (StringUtils.isBlank(request.getParameter("squareFeet"))) ? 0 : form.getSquareFeet()
            , (StringUtils.isBlank(request.getParameter("description"))) ? null : form.getDescription()
            , (StringUtils.isBlank(request.getParameter("code"))) ? null : form.getCode()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("home"))) ? null : form.getHome()
            , (StringUtils.isBlank(request.getParameter("flowers"))) ? null : form.getFlowers()
        );

        return preload(mapping, actionForm, request, response);
    }

    public ActionForward read(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final GardenForm form = (GardenForm)actionForm;

        final List list = ManageableServiceLocator.instance().getGardenManageableService().read(
            (StringUtils.isBlank(request.getParameter("squareFeet"))) ? 0 : form.getSquareFeet()
            , (StringUtils.isBlank(request.getParameter("description"))) ? null : form.getDescription()
            , (StringUtils.isBlank(request.getParameter("code"))) ? null : form.getCode()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("home"))) ? null : form.getHome()
            , (StringUtils.isBlank(request.getParameter("flowers"))) ? null : form.getFlowers()
        );
        form.setManageableList(list);

        if (list.size() >= 250)
        {
            saveMaxResultsWarning(request);
        }

        final Map backingLists = ManageableServiceLocator.instance().getGardenManageableService().readBackingLists();
        form.setHomeBackingList((List)backingLists.get("home"));
        form.setFlowersBackingList((List)backingLists.get("flowers"));

        return mapping.getInputForward();
    }

    public ActionForward preload(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final GardenForm form = (GardenForm)actionForm;

        final List list = ManageableServiceLocator.instance().getGardenManageableService().readAll();
        form.setManageableList(list);


        if (list.size() >= 250)
        {
            saveMaxResultsWarning(request);
        }

        final Map backingLists = ManageableServiceLocator.instance().getGardenManageableService().readBackingLists();
        if (StringUtils.isNotBlank(request.getParameter("ref_Home")))
        {
            form.setHome(new Long(request.getParameter("ref_Home")));
        }
        form.setHomeBackingList((List)backingLists.get("home"));
        if (StringUtils.isNotBlank(request.getParameter("ref_Flower")))
        {
            final Long[] array = new Long[1];
            array[0] = new Long(request.getParameter("ref_Flower"));
            form.setFlowers(array);
        }
        form.setFlowersBackingList((List)backingLists.get("flowers"));

        return mapping.getInputForward();
    }

    protected ActionForward unspecified(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        return preload(mapping, actionForm, request, response);
    }

    public ActionForward update(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final GardenForm form = (GardenForm) actionForm;

        ManageableServiceLocator.instance().getGardenManageableService().update(
            (StringUtils.isBlank(request.getParameter("squareFeet"))) ? 0 : form.getSquareFeet()
            , (StringUtils.isBlank(request.getParameter("description"))) ? null : form.getDescription()
            , (StringUtils.isBlank(request.getParameter("code"))) ? null : form.getCode()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("home"))) ? null : form.getHome()
            , (StringUtils.isBlank(request.getParameter("flowers"))) ? null : form.getFlowers()
        );

        return preload(mapping, actionForm, request, response);
    }

    public ActionForward delete(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final GardenForm form = (GardenForm) actionForm;

        final Long[] selectedRows = form.getSelectedRows();
        if (selectedRows != null && selectedRows.length > 0)
        {
            ManageableServiceLocator.instance().getGardenManageableService().delete(selectedRows);
        }

        return preload(mapping, actionForm, request, response);
    }

    private void saveMaxResultsWarning(HttpServletRequest request)
    {
        final HttpSession session = request.getSession();

        ActionMessages messages = (ActionMessages)session.getAttribute(Globals.MESSAGE_KEY);
        if (messages == null)
        {
            messages = new ActionMessages();
            session.setAttribute(Globals.MESSAGE_KEY, messages);
        }
        messages.add("org.andromda.bpm4struts.warningmessages", new ActionMessage("maximum.results.fetched.warning", "250"));
    }

}